import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class BorderDemoPanel extends JPanel
{
   // the following fields must be global to be visible to the listener
   JPanel labelPanel = new JPanel();
   private JLabel label;
   // radio buttons to select text color
   JRadioButton textRed = new JRadioButton("text red");
   JRadioButton textBlue = new JRadioButton("text blue");
   JRadioButton textGray = new JRadioButton("text gray");
   // radio buttons to select background color
   JRadioButton bgRed = new JRadioButton("background red");
   JRadioButton bgBlue = new JRadioButton("background blue");
   JRadioButton bgGray = new JRadioButton("background gray");
   
   public BorderDemoPanel()
   {
      // use a border layout for three panels
      setLayout(new BorderLayout());
      label = new JLabel("Radio Button and Border Layout Demo");
      // text in a large font
      label.setFont(new Font("Helvetica", Font.PLAIN, 36));
      // top label holds text
      labelPanel.add(label);
      // common listener for all radio buttons
      RBListener listener = new RBListener();
      // set up text buttons
      // middle panel holds buttons for text color
      JPanel textButtonPanel = new JPanel();
      ButtonGroup textGroup = new ButtonGroup();
      textGroup.add(textRed);
      textGroup.add(textBlue);
      textGroup.add(textGray);
      textRed.addActionListener(listener);
      textBlue.addActionListener(listener);
      textGray.addActionListener(listener);
      textButtonPanel.add(textRed);
      textButtonPanel.add(textBlue);
      textButtonPanel.add(textGray);
      // lower panel holds buttons for background color
      // set up background buttons
      JPanel backgroundButtonPanel = new JPanel();
      ButtonGroup bgGroup = new ButtonGroup();
      bgGroup.add(bgRed);
      bgGroup.add(bgBlue);
      bgGroup.add(bgGray);
      bgRed.addActionListener(listener);
      bgBlue.addActionListener(listener);
      bgGray.addActionListener(listener);
      backgroundButtonPanel.add(bgRed);
      backgroundButtonPanel.add(bgBlue);
      backgroundButtonPanel.add(bgGray);
      // collect 3 panels into one -- use BorderLayout
      add(labelPanel, BorderLayout.NORTH);
      add(textButtonPanel, BorderLayout.WEST);
      add(backgroundButtonPanel, BorderLayout.CENTER);
      textButtonPanel.setBorder(BorderFactory.createEtchedBorder());
      backgroundButtonPanel.setBorder(BorderFactory.createEtchedBorder());
      labelPanel.setBorder(BorderFactory.createLineBorder(Color.black, 2));      
   }
   
   private class RBListener implements ActionListener
   {
      public void actionPerformed(ActionEvent e)
      {
         // select color of text or background by detecting button selected
         if (e.getSource() == textRed)
            label.setForeground(Color.red);
         else if (e.getSource() == textBlue)
            label.setForeground(Color.blue);
         else if (e.getSource() == textGray)
            label.setForeground(Color.gray);
         else if (e.getSource() == bgRed)
            labelPanel.setBackground(Color.red);
         else if (e.getSource() == bgBlue)
            labelPanel.setBackground(Color.blue);
         else if (e.getSource() == bgGray)
            labelPanel.setBackground(Color.gray);
      }
   }
}

