import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RBDemoPanel extends JPanel
{
   // the following fields must be global to be visible to the listener
   private JLabel label;
   // radio buttons to select text color   
   JRadioButton textRed = new JRadioButton("text red");
   JRadioButton textBlue = new JRadioButton("text blue");
   JRadioButton textGray = new JRadioButton("text gray");
   // radio buttons to select background color
   JRadioButton bgRed = new JRadioButton("background red");
   JRadioButton bgBlue = new JRadioButton("background blue");
   JRadioButton bgGray = new JRadioButton("background gray");
   
   public RBDemoPanel()
   {
      // text to display in a large font
      label = new JLabel("Radio Button Demo");
      label.setFont(new Font("Helvetica", Font.PLAIN, 36));
      add(label);
      // single listener for all radio buttons
      RBListener listener = new RBListener();
      // set up text buttons
      // group for three buttons controling text color
      ButtonGroup textGroup = new ButtonGroup();
      textGroup.add(textRed);
      textGroup.add(textBlue);
      textGroup.add(textGray);
      // add same listener instance to all buttons
      textRed.addActionListener(listener);
      textBlue.addActionListener(listener);
      textGray.addActionListener(listener);
      add(textRed);
      add(textBlue);
      add(textGray);
      // set up background buttons
      // group for three buttons controling background color
      ButtonGroup bgGroup = new ButtonGroup();
      bgGroup.add(bgRed);
      bgGroup.add(bgBlue);
      bgGroup.add(bgGray);
      // add same listener (as above) to all buttons
      bgRed.addActionListener(listener);
      bgBlue.addActionListener(listener);
      bgGray.addActionListener(listener);
      add(bgRed);
      add(bgBlue);
      add(bgGray);
   }
   
   private class RBListener implements ActionListener
   {
      public void actionPerformed(ActionEvent e)
      {
         // change text or background color according to which
         // button created the event
         if (e.getSource() == textRed)
            label.setForeground(Color.red);
         else if (e.getSource() == textBlue)
            label.setForeground(Color.blue);
         else if (e.getSource() == textGray)
            label.setForeground(Color.gray);
         else if (e.getSource() == bgRed)
            setBackground(Color.red);
         else if (e.getSource() == bgBlue)
            setBackground(Color.blue);
         else if (e.getSource() == bgGray)
            setBackground(Color.gray);
      }
   }
}

